%define anolis_release 3

Summary: The standard UNIX FTP (File Transfer Protocol) client
Name: ftp
Version: 0.17
Release: %{anolis_release}%{dist}
License: BSD with advertising
URL: ftp://ftp.linux.org.uk/pub/linux/Networking/netkit

Source0: http://ftp.debian.org/debian/pool/main/n/netkit-ftp/netkit-ftp_%{version}.orig.tar.gz 
#-O "netkit-ftp-#%%{version}.tar.gz"

Patch0001: 0001-PATCH-netkit-ftp-0.17-pre20000412.pasv-security.patch
Patch0002: 0002-PATCH-netkit-ftp-0.17-acct.patch
Patch0003: 0003-PATCH-netkit-ftp.usagi-ipv6.patch
Patch0004: 0004-PATCH-netkit-ftp-0.17-segv.patch
Patch0005: 0005-PATCH-netkit-ftp-0.17-volatile.patch
Patch0006: 0006-PATCH-netkit-ftp-0.17-runique_mget.patch
Patch0007: 0007-PATCH-netkit-ftp-locale.patch
Patch0008: 0008-PATCH-netkit-ftp-0.17-printf.patch
Patch0009: 0009-PATCH-netkit-ftp-0.17-longint.patch
Patch0010: 0010-PATCH-netkit-ftp-0.17-vsftp165083.patch
Patch0011: 0011-PATCH-netkit-ftp-0.17-C-Frame121.patch
Patch0012: 0012-PATCH-netkit-ftp-0.17-data.patch
Patch0013: 0013-PATCH-netkit-ftp-0.17-multihome.patch
Patch0014: 0014-PATCH-netkit-ftp-0.17-longnames.patch
Patch0015: 0015-PATCH-netkit-ftp-0.17-multiipv6.patch
Patch0016: 0016-PATCH-netkit-ftp-0.17-nodebug.patch
Patch0017: 0017-PATCH-netkit-ftp-0.17-stamp.patch
Patch0018: 0018-PATCH-netkit-ftp-0.17-sigseg.patch
Patch0019: 0019-PATCH-netkit-ftp-0.17-size.patch
Patch0020: 0020-PATCH-netkit-ftp-0.17-fdleak.patch
Patch0021: 0021-PATCH-netkit-ftp-0.17-fprintf.patch
Patch0022: 0022-PATCH-netkit-ftp-0.17-bitrate.patch
Patch0023: 0023-PATCH-netkit-ftp-0.17-arg_max.patch
Patch0024: 0024-PATCH-netkit-ftp-0.17-case.patch
Patch0025: 0025-PATCH-netkit-ftp-0.17-chkmalloc.patch
Patch0026: 0026-PATCH-netkit-ftp-0.17-man.patch
Patch0027: 0027-PATCH-netkit-ftp-0.17-acct_ovl.patch
Patch0028: 0028-PATCH-netkit-ftp-0.17-remove-nested-include.patch
Patch0029: 0029-PATCH-netkit-ftp-0.17-linelen.patch
Patch0030: 0030-PATCH-netkit-ftp-0.17-active-mode-option.patch
Patch0031: 0031-PATCH-netkit-ftp-0.17-commands-leaks.patch
Patch0032: 0032-PATCH-netkit-ftp-0.17-lsn-timeout.patch
Patch0033: 0033-PATCH-netkit-ftp-0.17-getlogin.patch
Patch0034: 0034-PATCH-netkit-ftp-0.17-token.patch
Patch0035: 0035-PATCH-netkit-ftp-0.17-linelen-segfault.patch
Patch0036: 0036-PATCH-netkit-ftp-0.17-out-of-memory.patch

BuildRequires: glibc-devel, readline-devel, ncurses-devel
BuildRequires: perl-interpreter, gcc
BuildRequires: make

%description
The ftp package provides the standard UNIX command-line FTP (File
Transfer Protocol) client.  FTP is a widely used protocol for
transferring files over the Internet and for archiving files.

If your system is on a network, you should install ftp in order to do
file transfers.

%prep
%setup -q -n netkit-ftp-%{version}
%patch1 -p1
%patch2 -p1 -b .acct
%patch3 -p1 -b .ipv6
%patch4 -p1 -b .segv
%patch5 -p1 -b .volatile
%patch6 -p1 -b .runique_mget
%patch7 -p1 -b .locale
%patch8 -p1 -b .printf
%patch9 -p1 -b .longint
%patch10 -p1 -b .vsftp165083
%patch11 -p1 -b .C-Frame121
%patch12 -p1 -b .data
%patch13 -p1 -b .multihome
%patch14 -p1 -b .patch
%patch15 -p1 -b .multiipv6
%patch16 -p1 -b .nodebug
%patch17 -p1 -b .stamp
%patch18 -p1 -b .sigseg
%patch19 -p1 -b .size
%patch20 -p1 -b .fdleak
%patch21 -p1 -b .fprintf
%patch22 -p1 -b .bitrate
%patch23 -p1 -b .arg_max
%patch24 -p1 -b .case
%patch25 -p1 -b .chkmalloc
%patch26 -p1 -b .man
%patch27 -p1 -b .acct_ovl
%patch28 -p1
%patch29 -p1 -b .linelen
%patch30 -p1 -b .activemode
%patch31 -p1 -b .cmds-leaks
%patch32 -p1 -b .lsn-timeout
%patch33 -p1 -b .getlogin
%patch34 -p1 -b .token
%patch35 -p1 -b .linelen-segfault
%patch36 -p1 -b .out-of-memory

%build
sh configure --with-c-compiler=%{__cc} --enable-ipv6
perl -pi -e '
    s,^CC=.*$,CC=cc,;
    s,-O2,\$(RPM_OPT_FLAGS) -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64,;
    s,^LDFLAGS=.*$,LDFLAGS=\$(RPM_LD_FLAGS),;
    s,^BINDIR=.*$,BINDIR=%{_bindir},;
    s,^MANDIR=.*$,MANDIR=%{_mandir},;
    s,^SBINDIR=.*$,SBINDIR=%{_sbindir},;
    ' MCONFIG

%{make_build}

%install
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man5

make INSTALLROOT=${RPM_BUILD_ROOT} install

%generate_compatibility_deps

%files
%dir %{abidir}
%{_bindir}/ftp
%{abidir}/ftp-option.list
%{_bindir}/pftp
%{_mandir}/man1/ftp.*
%{_mandir}/man1/pftp.*
%{_mandir}/man5/netrc.*

%changelog 
* Fri Dec 29 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 0.17-3
- fix the source error

* Mon Feb 13 2023 Guyu Wang <guyu.wgy@linux.alibaba.com> - 0.17-2
- Optimize spec file

* Wed Apr 13 2022 Zhongling He <zhonglingh@linux.alibaba.com> - 0.17-1
- Init package from upstream v0.17
